unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
  private
    procedure LoadCSVToGrid(AFileName: String);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  FILE_NAME = 'data.txt';   // Dateiname der CSV-Datei
  TRENNER = ';';            // Spalten-Trennzeichen in der CSV-Datei

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  LoadCSVToGrid(FILE_NAME);
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  StringGrid1.Columns[1].Visible := not Checkbox1.Checked;
end;

procedure TForm1.LoadCSVToGrid(AFileName: String);
var
  L: TStrings;
  sa: TStringArray;
  i, j, r, c: Integer;
begin
  L := TStringList.Create;
  try
    // Verhindern, dass die Leerzeichen in der Titelzeile eine neue Spalte bewirken
    L.StrictDelimiter := true;

    // Datei in die Stringliste einlesen
    L.LoadFromFile(AFileName);
    if L.Count = 0 then
      exit;  // Datei ist leer

    // Zahl der Elemente in der StringList bestimmt die Zeilenzahl im Grid
    StringGrid1.RowCount := L.Count;
    StringGrid1.FixedCols := 1;

    // 1. gelesene Zeile am Zeilentrenner, hier ein ';', auftrennen
    sa := L[0].Split(TRENNER);
    // Die gefundene Zahl der Arrayelemente ist gleich der Spaltenzahl
    for c := 0 to High(sa) do
      with StringGrid1.Columns.Add do
      begin
        Width := 100;
        Title.Caption := sa[c];
      end;

    // Nun die restlichen Zeilen einlesen und in die Grid-Zellen laden
    r := 1;
    for i:=1 to L.Count-1 do begin   // i=1, da die 0-te Zeile schon gelesen ist
      StringGrid1.Cells[0, r] := 'Zeile ' + IntToStr(r);
      if L[i] <> '' then begin
        sa := L[i].Split(TRENNER);
        c := StringGrid1.FixedCols;
        for j := 0 to High(sa) do
        begin
          StringGrid1.Cells[c, r] := sa[j];
          inc(c);
        end;
      end;
      inc(r);
    end;

  finally
    L.Free;
  end;
end;

end.

